#pragma once
#include <string>

template<typename Base>
class FactoryBase
{
public:
	FactoryBase(const std::string& name);
	virtual Base* generate() = 0;
	const std::string& name() const;
private:
	std::string _name;
};

template<typename Derived, typename Base>
class Factory
	: public FactoryBase<Base>
{
public:
	Factory(const std::string& name);
	virtual Base* generate();
};

#include <Factory.hpp>
