template<typename Base>
FactoryBase<Base>::FactoryBase(const std::string& name)
	: _name(name)
{
}

template<typename Base>
const std::string& FactoryBase<Base>::name() const
{
	return _name;
}

template<typename Derived, typename Base>
Factory<Derived, Base>::Factory(const std::string& name)
	: FactoryBase<Base>(name)
{
}

template<typename Derived, typename Base>
Base* Factory<Derived, Base>::generate()
{
	return new Derived();
}
