#pragma once
#include <Types.h>
#include <Generator.h>
#include <string>

class ParameterBase
{
public:
	ParameterBase(const std::string& name,
	              const std::string& description,
				  const DataType& dataType);

	const std::string& name() const;
	const std::string& description() const;
	const DataType& dataType() const;
private:
	std::string _name;
	std::string _description;
	DataType _dataType;
};

template<typename T>
class Parameter
	: public ParameterBase
{
public:
	Parameter(const std::string& name,
	          const std::string& description);
	void generator(Generator<T>* generator);
	Generator<T>* generator();
private:
	Generator<T>* _generator;
};

#include <Parameter.hpp>
