template<typename T>
Parameter<T>::Parameter(const std::string& name,
                        const std::string& description)
	: ParameterBase(name, description, TypeInfo<T>::dataType()),
	  _generator(nullptr)
{
}

template<typename T>
void Parameter<T>::generator(Generator<T>* generator)
{
	if (_generator)
		delete _generator;
	_generator = generator;
}

template<typename T>
Generator<T>* Parameter<T>::generator()
{
	return _generator;
}
