#include <QtGui>
#include <slug/spec/Cluster.h>

class Editor : public QMainWindow
{
	Q_OBJECT

public:
	Editor();

private slots:
	void open();
	void save();
	void hostfile();
	void machineSelected(QListWidgetItem* current, QListWidgetItem* previous);
	void machineEnabled(QListWidgetItem* item);
	void deviceSelected(QListWidgetItem* current, QListWidgetItem* previous);
	void deviceEnabled(QListWidgetItem* item);

private:
	typedef std::pair<QLabel*, QLabel*> LabelSet;
	LabelSet infoParam(const std::string& key, const std::string& value);

	void _updateCluster(slug::spec::Cluster* cluster);
	QAction* _openAction;
	QAction* _saveAction;
	QAction* _exitAction;
	QAction* _hostfileAction;

	QMenu* _fileMenu;

	QHBoxLayout* _mainLayout;
	QWidget* _mainWidget;

	QListWidget* _machineList;
	QGroupBox* _machineBox;
	slug::spec::Machine* _machine;

	QListWidget* _deviceList;
	QGroupBox* _deviceListBox;
	QGroupBox* _deviceBox;
	slug::spec::Device* _device;

	slug::spec::Cluster* _cluster;
};

