#include <slug/spec/Components.h>
#include <slug/util/BinaryStream.h>
#include <slug/util/Timer.h>
#include <iostream>
#include <chrono>

using namespace slug::spec;
using namespace slug;

int main(int argc, char** argv)
{
	if (argc != 2)
	{
		std::cerr << "Usage: " << argv[0] << " <clusterFile>" << std::endl;
		return -1;
	}

	Cluster* cluster = Cluster::build(argv[1]);

	if (nullptr == cluster)
	{
		std::cerr << "Failed to open input file" << std::endl;
		return -1;
	}

	std::cout << cluster->machines.size() << " machines" << std::endl;
	std::cout << std::endl;
	for (auto machine : cluster->machines)
	{
		std::cout << "\tMachine Name: " << machine->name << std::endl;
		std::cout << "\t\t" << machine->devices.size() << " devices" 
		    << std::endl;
		for (auto device : machine->devices)
		{
			std::cout << "\t\t\tDevice Type: " << device->type() << std::endl;
			std::cout << "\t\t\tPower: " << device->power << std::endl;
			std::cout << std::endl;
		}
		std::cout << std::endl;
	}

	delete cluster;

	return 0;
}
