############################### Define Column Shells #########################
COLUMN_SHELL
    TYPE           SUB_LEFT_SHELL
    WIDTH          300
    HEIGHT         800
    LOCATION       0             0
END_COLUMN_SHELL

############################### Fill Columns #################################
COLUMN
    TYPE           SUB_LEFT_COLUMN
    COLUMN_SHELL   SUB_LEFT_SHELL
    LAYER_TYPE     layer_SUB_LEFT
END_COLUMN

############################### Define Layer Shells #########################
LAYER_SHELL
    TYPE           layer_SUB_LEFT_shell
    LOWER          0
    UPPER          100
END_LAYER_SHELL

############################### Fill Layers ##################################
LAYER
	TYPE			layer_SUB_LEFT
	LAYER_SHELL		layer_SUB_LEFT_shell
	CELL_TYPE		SUB_LEFT_E_RS     80
    CELL_TYPE		SUB_LEFT_E_SB     80
	CELL_TYPE		SUB_LEFT_I        20

##############################################################################
# ----- I-E within group
##############################################################################
    CONNECT
                    SUB_LEFT_I          somaI
                    SUB_LEFT_E_RS       somaE
                    synIE_SUB   0.2   0

    CONNECT
                    SUB_LEFT_I          somaI
                    SUB_LEFT_E_SB       somaE
                    synIE_SUB   0.2   0

    CONNECT
                    SUB_LEFT_E_SB        somaE
                    SUB_LEFT_E_RS        somaE
                    synEE_SUB   0.1   0

END_LAYER

#############################################################################
############################### Define Cells ################################
CELL
    TYPE            SUB_LEFT_I
    COMPARTMENT     soma_inhib_SUB  somaI   0   0   0
END_CELL

CELL
    TYPE            SUB_LEFT_E_RS
    COMPARTMENT     soma_exc_SUB_RS    somaE   0   0   0
END_CELL

CELL
    TYPE            SUB_LEFT_E_SB
    COMPARTMENT     soma_exc_SUB_SB    somaE   0   0   0
END_CELL


#########################
## Define Compartments  
#########################


COMPARTMENT
    TYPE              soma_inhib_SUB
    SPIKESHAPE        spikeshape_1k_default
    TAU_MEMBRANE      0.020       0.0
    R_MEMBRANE        200         0
    THRESHOLD         -50         0
    VMREST            -60         0
    LEAK_REVERSAL     0.0         0.0
    LEAK_CONDUCTANCE  0.0         0.0
END_COMPARTMENT


COMPARTMENT
    TYPE              soma_exc_SUB_RS
    SPIKESHAPE        spikeshape_1k_default
    #SPIKESHAPE       spikeshape_cell_1
    #SPIKESHAPE       spikeshape_bursting_neurons #for use in forcing the figure
    TAU_MEMBRANE      0.020       0.0
    R_MEMBRANE        200         0
    THRESHOLD         -50         0
    VMREST            -60         0
    LEAK_REVERSAL     0.0         0.0
    LEAK_CONDUCTANCE  0.0         0.0
    CA_INTERNAL            	5.0         0.0
    CA_EXTERNAL             0.0         0.0
    CA_SPIKE_INCREMENT      100        0.0
    CA_TAU                  0.08      0.0
    CHANNEL            ahp_SUB_RS
    #CHANNEL           Ca_HVA
    #CHANNEL           Ca_LVA          
END_COMPARTMENT

COMPARTMENT
    TYPE              soma_exc_SUB_SB
    #SPIKESHAPE       spikeshape_1k_default
    SPIKESHAPE        spikeshape_cell_1
    #SPIKESHAPE       spikeshape_bursting_neurons #for use in forcing the figure
    TAU_MEMBRANE      0.020       0.0
    R_MEMBRANE        200         0
    THRESHOLD         -50         0
    VMREST            -60         0
    LEAK_REVERSAL     0.0         0.0
    LEAK_CONDUCTANCE  0.0         0.0
    CA_INTERNAL            	5.0         0.0
    CA_EXTERNAL             0.0         0.0
    CA_SPIKE_INCREMENT      100        0.0
    CA_TAU                  0.03      0.0
    CHANNEL           ahp_SUB_SB
    CHANNEL           Ca_HVA
    CHANNEL           Ca_LVA          
END_COMPARTMENT


#########################  Define Channels #################################


CHANNEL Kahp
        TYPE                            ahp_SUB_SB
     #  SEED                            999999
        M_INITIAL                       0.0             0.0
        REVERSAL_POTENTIAL              -80             0 
        M_POWER                         2
        UNITARY_G                       6
        STRENGTH                        0.0108125
        CA_SCALE_FACTOR                 0.000125
        CA_EXP_FACTOR                   2
        CA_HALF_MIN                     2.5
        CA_TAU_SCALE_FACTOR             0.01
END_CHANNEL

CHANNEL Kahp
        TYPE                            ahp_SUB_RS
     #  SEED                            999999
        M_INITIAL                       0.0             0.0
        REVERSAL_POTENTIAL              -80             0 
        M_POWER                         2
        UNITARY_G                       6
        STRENGTH                        0.0158125
        CA_SCALE_FACTOR                 0.000125
        CA_EXP_FACTOR                   2
        CA_HALF_MIN                     2.5
        CA_TAU_SCALE_FACTOR             0.01
END_CHANNEL

CHANNEL Km #HVA
        TYPE                            Ca_HVA
        M_INITIAL                       0.0             0.0
        REVERSAL_POTENTIAL              102               4
        M_POWER                         1
        E_HALF_MIN_M                    2
        SLOPE_FACTOR_M                  5  12  2.5
        TAU_SCALE_FACTOR_M              0.1
        UNITARY_G                       5
        STRENGTH                        0.00055
        #STRENGTH                       0.0
END_CHANNEL

CHANNEL Km #LVA
        TYPE                            Ca_LVA
        M_INITIAL                       0.0             0.0
        REVERSAL_POTENTIAL              102               4
        M_POWER                         1
        E_HALF_MIN_M                    -31
        SLOPE_FACTOR_M                  6 20 4.5
        TAU_SCALE_FACTOR_M              0.025
        UNITARY_G                       5
        STRENGTH                        0.000458333
        #STRENGTH                       0.0
END_CHANNEL

######################### 
## Define Spikeshape  
######################### 

SPIKESHAPE
  TYPE      spikeshape_cell_1
  VOLTAGES  -38 30 -38 -43
END_SPIKESHAPE

