
############################### Define SYNAPSES ##############################
SYNAPSE
	TYPE			synEE_PCR
	SFD_LABEL		NO_SFD
	LEARN_LABEL     STDP_DAN_D2
    #LEARN_LABEL		NO_LEARN_D
	SYN_PSG         PSGexcit
	MAX_CONDUCT		0.004		0.0
	DELAY			0.001		0.005
	SYN_REVERSAL	0           0
	ABSOLUTE_USE	0.5		    0.05

    HEBB_END		0.0 
	HEBB_START		0.1   
    HEBB_END        100
END_SYNAPSE

SYNAPSE
	TYPE			synEI_PCR
	SFD_LABEL		NO_SFD
	LEARN_LABEL		NO_LEARN
	SYN_PSG         PSGexcit
	MAX_CONDUCT		0.004		0.0
	DELAY			0.001		0.005
	SYN_REVERSAL	0           0
	ABSOLUTE_USE	0.5		0.05
END_SYNAPSE

SYNAPSE
	TYPE			synIE_PCR
	SFD_LABEL		NO_SFD
	LEARN_LABEL		NO_LEARN
	SYN_PSG         PSGinhib
	MAX_CONDUCT		0.2       0.0
	DELAY			0.001		0.001
	SYN_REVERSAL	-80         0
	ABSOLUTE_USE	0.5		0.05
END_SYNAPSE

SYNAPSE
	TYPE			synII_PCR
	SFD_LABEL		NO_SFD
	LEARN_LABEL		NO_LEARN
	SYN_PSG         PSGinhib
	MAX_CONDUCT		0.075  	0.0
	DELAY			0.001		0.001
	SYN_REVERSAL	-80         0
	ABSOLUTE_USE	0.5		0.05
END_SYNAPSE

###########################  SFD  ##########################################
#-----SYNAPSE W/O SFD
SYN_FACIL_DEPRESS
        TYPE                    NO_SFD
        SFD                     NONE
        FACIL_TAU               0.0           0.0
        DEPR_TAU                0.0           0.0
END_SYN_FACIL_DEPRESS

############################### Long-term synaptic Dynamics ##################
SYN_LEARNING
        TYPE                    NO_LEARN
        LEARNING                NONE
        LEARNING_SHAPE          EXPONENT
        NEG_HEB_WINDOW          0.1            0.0
        POS_HEB_WINDOW          0.05            0.0
        POS_HEB_PEAK_DELTA_USE  0.02            0.0
        NEG_HEB_PEAK_DELTA_USE  0.01            0.0
        POS_HEB_PEAK_TIME       0.005           0.0
        NEG_HEB_PEAK_TIME       0.005           0.0
END_SYN_LEARNING

# mod from Froemke RC, Poo MM, Dan Y. Nature 2005, PMID: 15759002 
SYN_LEARNING
        TYPE                    STDP_DAN_D2
        LEARNING                BOTH
        LEARNING_SHAPE          EXPONENT
        POS_HEB_WINDOW          0.05           0.0
        NEG_HEB_WINDOW          0.09           0.0

        POS_HEB_PEAK_DELTA_USE  0.003         0.0
        NEG_HEB_PEAK_DELTA_USE  0.003          0.0

        POS_HEB_PEAK_TIME       0.015           0.0
        NEG_HEB_PEAK_TIME       0.03           0.0
# Note: _PEAK_TIMES are the expon TAU values in EXPONENT mode
END_SYN_LEARNING

############################### synaptic CONDUCTANCE WAVEFORMS ###############
SYN_PSG
        TYPE                    PSGexcit
        PSG_FILE                EPSG_Vogels_FSV1k_TAU05.inc
END_SYN_PSG

SYN_PSG
        TYPE                    PSGinhib
        PSG_FILE                IPSG_Vogels_FSV1k_TAU10.inc
END_SYN_PSG


