#include <slug/sim/InputSimulator.h>

using namespace slug;

template<util::MemoryType MType>
class DummySimulator : public sim::InputSimulator<MType>
{
public:
	virtual bool init(const sim::SimulationProperties* properties)
	{
		return true;
	}

	virtual void update(slug::sim::InputBuffer<MType>* buffer)
	{
	}
};

template<util::MemoryType MType>
void add()
{
	auto sim = 
		new sim::SpecificFactory<sim::InputSimulator<MType>,
		                         DummySimulator<MType>>
			("dummy", "dummy", 0);
	sim::Manager<sim::Factory<sim::InputSimulator<MType>>>::add(sim);
}

extern "C"
{

void activate()
{
	add<util::MemoryType::System>();
	add<util::MemoryType::CUDA>();
	add<util::MemoryType::OpenCL>();
}

}
