#pragma once
#include <slug/sim/InputSimulator.h>
#include <Mode.h>

template<slug::util::MemoryType MType, Mode mode>
class LinearSimulator
	: public slug::sim::InputSimulator<MType>
{
public:
	virtual bool init(const slug::sim::SimulationProperties* properties);

	virtual void update(slug::sim::InputBuffer<MType>* buffer);
private:
	struct Bundle
	{
		unsigned int* indices;
		unsigned int size;
		float slope;
		float startingAmplitude;
	};
	struct Event
	{
		float startTime;
		float endTime;
		float duration;
		Bundle* bundle;
	};
	std::list<Event*> _events;
	std::vector<Bundle*> _bundles;
	std::vector<Event*> _storedEvents;
	std::list<Event*> _activeEvents;
	float _timestep;
	float _elapsedTime;

	void _processEvent(Event* e, slug::sim::InputBuffer<MType>* buffer);
};

#include <Linear.hpp>
