#include <Linear.h>
#include <Pulse.h>


extern "C"
{

void activate()
{

  {
	  static const auto type = slug::util::MemoryType::CUDA;
	  typedef slug::sim::InputSimulator<type> simType;
	  typedef LinearSimulator<type, Mode::Current> currentSim;
	  typedef LinearSimulator<type, Mode::Voltage> voltageSim;
	  typedef slug::sim::Factory<simType> factoryType;
	  {
		  auto sim =
			  new slug::sim::SpecificFactory<simType, currentSim>
			  ("ncs5LinearCurrent", "ncs5LinearCurrent", 0);
		  slug::sim::Manager<factoryType>::add(sim);
	  }
	  {
		  auto sim =
			  new slug::sim::SpecificFactory<simType, voltageSim>
			  ("ncs5LinearVoltage", "ncs5LinearVoltage", 0);
		  slug::sim::Manager<factoryType>::add(sim);
	  }
  }
  {
	  static const auto type = slug::util::MemoryType::CUDA;
	  typedef slug::sim::InputSimulator<type> simType;
	  typedef PulseSimulator<type, Mode::Current> currentSim;
	  typedef PulseSimulator<type, Mode::Voltage> voltageSim;
	  typedef slug::sim::Factory<simType> factoryType;
	  {
		  auto sim =
			  new slug::sim::SpecificFactory<simType, currentSim>
			  ("ncs5PulseCurrent", "ncs5PulseCurrent", 0);
		  slug::sim::Manager<factoryType>::add(sim);
	  }
	  {
		  auto sim =
			  new slug::sim::SpecificFactory<simType, voltageSim>
			  ("ncs5PulseVoltage", "ncs5PulseVoltage", 0);
		  slug::sim::Manager<factoryType>::add(sim);
	  }
  }

  {
	  static const auto type = slug::util::MemoryType::System;
	  typedef slug::sim::InputSimulator<type> simType;
	  typedef LinearSimulator<type, Mode::Current> currentSim;
	  typedef LinearSimulator<type, Mode::Voltage> voltageSim;
	  typedef slug::sim::Factory<simType> factoryType;
	  {
		  auto sim =
			  new slug::sim::SpecificFactory<simType, currentSim>
			  ("ncs5LinearCurrent", "ncs5LinearCurrent", 0);
		  slug::sim::Manager<factoryType>::add(sim);
	  }
	  {
		  auto sim =
			  new slug::sim::SpecificFactory<simType, voltageSim>
			  ("ncs5LinearVoltage", "ncs5LinearVoltage", 0);
		  slug::sim::Manager<factoryType>::add(sim);
	  }
  }
  {
	  static const auto type = slug::util::MemoryType::System;
	  typedef slug::sim::InputSimulator<type> simType;
	  typedef PulseSimulator<type, Mode::Current> currentSim;
	  typedef PulseSimulator<type, Mode::Voltage> voltageSim;
	  typedef slug::sim::Factory<simType> factoryType;
	  {
		  auto sim =
			  new slug::sim::SpecificFactory<simType, currentSim>
			  ("ncs5PulseCurrent", "ncs5PulseCurrent", 0);
		  slug::sim::Manager<factoryType>::add(sim);
	  }
	  {
		  auto sim =
			  new slug::sim::SpecificFactory<simType, voltageSim>
			  ("ncs5PulseVoltage", "ncs5PulseVoltage", 0);
		  slug::sim::Manager<factoryType>::add(sim);
	  }
  }

}

}
