#pragma once
#include <ProbabilityBuffer.h>
#include <map>
#include <thread>

class Connection
	: public slug::sim::SpecificPublisher<ProbabilityBuffer>
{
public:
	bool connect(const std::string& server,
	             unsigned int port,
				 unsigned int numColumns,
				 float timeInverval,
				 const std::string& name);

	void run(unsigned int numSteps);
private:
	int _socketDescriptor;	
	std::once_flag _once;
	unsigned int _numColumns;
	float _timeInterval;
	std::thread _myThread;
};

class Connections
{
public:
	static Connection* get(const std::string& server,
	                       unsigned int port,
						   unsigned int numColumns,
						   float timeInverval,
						   const std::string& name);
private:
	typedef std::map<std::string, Connection*> NameToConnectionMap;
	typedef std::map<unsigned int, NameToConnectionMap> PortToNameMap;
	typedef std::map<std::string, PortToNameMap> ServerToPortMap;
	static ServerToPortMap _servers;
	static std::mutex _lock;
};
