#include <slug/sim/NeuronSimulator.h>

using namespace slug;
using namespace slug::sim;

template<util::MemoryType MType>
class DummySimulator : public sim::NeuronSimulator<MType>
{
public:
	virtual bool init(const SimulationProperties* properties)
	{
		return true;
	}

	virtual void initVoltages(float* voltages,
	                          const SimulationProperties* properties)
	{
	}

	typedef typename NeuronSimulator<MType>::UpdateParameters
		UpdateParameters;

	virtual void update(UpdateParameters& parameters)
	{
	}
};

template<util::MemoryType MType>
void add()
{
	auto sim = 
		new sim::SpecificFactory<sim::NeuronSimulator<MType>,
		                         DummySimulator<MType>>
			("dummy", "dummy", 0);
	sim::Manager<sim::Factory<sim::NeuronSimulator<MType>>>::add(sim);
}

extern "C"
{

void activate()
{
	add<util::MemoryType::System>();
	add<util::MemoryType::CUDA>();
	add<util::MemoryType::OpenCL>();
}

}
