#include <slug/sim/NeuronSimulator.h>
#include "CUDA.h"

using namespace slug;
using namespace slug::sim;

class CUDAEchoSimulator : public sim::NeuronSimulator<util::MemoryType::CUDA>
{
public:
	static const auto MType = util::MemoryType::CUDA;
	CUDAEchoSimulator()
	{
	}

	virtual bool init(const SimulationProperties* properties)
	{
		return true;
	}

	virtual void initVoltages(float* voltages,
	                          const SimulationProperties* properties)
	{
	}

	typedef typename NeuronSimulator<MType>::UpdateParameters
		UpdateParameters;

	virtual void update(UpdateParameters& parameters);
};

void CUDAEchoSimulator::update(UpdateParameters& parameters)
{
	echo(parameters.inputCurrent, 
	     parameters.neuronFireVector, 
		 parameters.neuronVoltage, 
		 numNeurons);
}

extern "C"
{

void activate()
{
	{
		static const auto type = util::MemoryType::CUDA;
		auto sim =
			new sim::SpecificFactory<sim::NeuronSimulator<type>,
			                         CUDAEchoSimulator>("echo", "echo", 0);
		sim::Manager<sim::Factory<sim::NeuronSimulator<type>>>::add(sim);
	}
}

}
