/*
	ChannelCurrentBuffer.h
*/

#pragma once

#include <slug/sim/DataBuffer.h>

template<slug::util::MemoryType MType>
class ChannelCurrentBuffer 
	: public slug::sim::DataBuffer,
	  public slug::util::Memory<MType>
{
public:
	ChannelCurrentBuffer(unsigned int _size)
		: size(_size),
		  currentBuffer(nullptr)
	{
		if (size > 0)
		{
			currentBuffer = this->template _allocate<float>(size);
		}

		_setPin(slug::util::StringID::get("channelCurrent"), 
		        currentBuffer, MType);
	}

	void clear()
	{
		this->template _zero<float>(currentBuffer, size);
	}

	~ChannelCurrentBuffer()
	{
		if (currentBuffer)
			this->_deallocate(currentBuffer);
		
		currentBuffer = nullptr;
	}

	unsigned int size;
	float* currentBuffer;
};
