#pragma once
#include <slug/sim/Parameterized.h>
#include <slug/util/Memory.h>
#include <slug/util/Unique.h>
#include <slug/sim/SimulationProperties.h>

template<slug::util::MemoryType MType>
class ChannelSimulator
	: public slug::sim::Parameterized,
	  public slug::util::Memory<MType>
{
public:
	virtual bool init(const slug::sim::SimulationProperties* properties) = 0;

	unsigned int numChannels;
	
	unsigned int* compartmentIDs;

	float* mPower;
	
	float* unitaryG;
	
	float* strength;

	float* m;

	float* reversalPotential;

	struct UpdateParameters
	{
		const float* compartmentVoltages;
		float* compartmentCalcium;
		float* compartmentCurrents;
	};

	virtual void update(UpdateParameters& parameters) = 0;

	bool read(const void* p);

	template<typename T>
	T* loadParameter(const std::string& name);

	virtual ~ChannelSimulator();
private:
};

#include "ChannelSimulator.hpp"
