#pragma once

#include <CompartmentStateBuffer.h>
#include <ChannelCurrentBuffer.h>
#include <slug/sim/Updater.h>
#include <ChannelSimulator.h>
#include <slug/sim/SimulationProperties.h>
#include <slug/sim/Device.h>

template<slug::util::MemoryType MType>
class ChannelUpdater : public slug::sim::Updater<ChannelCurrentBuffer<MType>>
{
public:
	ChannelUpdater(unsigned int numCompartments,
	               std::vector<ChannelSimulator<MType>*> simulators,
				   unsigned int numBuffers = 3);

	typedef slug::sim::SpecificPublisher<CompartmentStateBuffer<MType>>
		CompartmentPubisher;
	void compartmentStatePublisher(CompartmentPubisher* publisher);

	bool run(const slug::sim::SimulationProperties* properties);

	bool init(const slug::sim::SimulationProperties* properties);

private:
	unsigned int _numBuffers;

	unsigned int _numCompartments;

	std::vector<ChannelSimulator<MType>*> _simulators;

	slug::sim::Subscription<CompartmentStateBuffer<MType>>*
		_compartmentStateSubscription;

};

#include <ChannelUpdater.hpp>
