/*
	CompartmentStateBuffer.h
*/

#pragma once

#include <slug/sim/DataBuffer.h>

template<slug::util::MemoryType MType>
class CompartmentStateBuffer
	: public slug::sim::DataBuffer,
	  public slug::util::Memory<MType>
{
public:
	CompartmentStateBuffer(unsigned int _size)
		: size(_size)
	{
		if (size > 0)
		{
			voltages = this->template _allocate<float>(size);
			calcium = this->template _allocate<float>(size);
		}
	};

	unsigned int size;

	float* voltages;

	float* calcium;
};
