#pragma once

#include <ChannelSimulator.h>

template<slug::util::MemoryType MType>
class KaChannelSimulator
	: public ChannelSimulator<MType>
{
public:
	virtual bool init(const slug::sim::SimulationProperties* properties);

	typedef typename ChannelSimulator<MType>::UpdateParameters
		UpdateParameters;

	virtual void update(UpdateParameters& parameters);
private:
	unsigned int* _tauMIndices;
	float* _tauMVoltage;
	float* _tauMValue;
	float* _eHalfMinM;
	float* _slopeFactorM;

	unsigned int* _tauHIndices;
	float* _tauHVoltage;
	float* _tauHValue;
	float* _eHalfMinH;
	float* _slopeFactorH;

	float* _h;
	float* _hPower;

	float _timestep;
};

#include <KaChannel.hpp>

