#pragma once

#include <ChannelSimulator.h>

template<slug::util::MemoryType MType>
class KahpChannelSimulator
	: public ChannelSimulator<MType>
{
public:
	virtual bool init(const slug::sim::SimulationProperties* properties);

	typedef typename ChannelSimulator<MType>::UpdateParameters
		UpdateParameters;

	virtual void update(UpdateParameters& parameters);
private:
	float* _caScaleFactor;
	float* _caExpFactor;
	float* _caHalfMin;
	float* _caTauScaleFactor;
	float _timestep;
};

#include <KahpChannel.hpp>
