/*
	Implementation file for KahpChannel.h
	namespace 
*/

template<slug::util::MemoryType MType>
bool KahpChannelSimulator<MType>::
	init(const slug::sim::SimulationProperties* properties)
{
	this->require("caScaleFactor");
	this->require("caExpFactor");
	this->require("caHalfMin");
	this->require("caTauScaleFactor");
	
	if (!this->validate())
		return false;
	
	_caScaleFactor = this->template loadParameter<float>("caScaleFactor");
	_caExpFactor = this->template loadParameter<float>("caExpFactor");
	_caHalfMin = this->template loadParameter<float>("caHalfMin");
	_caTauScaleFactor = 
		this->template loadParameter<float>("caTauScaleFactor");

	_timestep = properties->timestep;

	return true;
}
