/*
	Implementation file for KmChannel.h
	namespace
*/

template<slug::util::MemoryType MType>
bool KmChannelSimulator<MType>::
	init(const slug::sim::SimulationProperties* properties)
{
	this->require("eHalfMinM");
	this->require("slopeFactorM0");
	this->require("slopeFactorM1");
	this->require("slopeFactorM2");
	this->require("tauScaleFactorM");

	if (!this->validate())
		return false;

	_eHalfMinM = this->template loadParameter<float>("eHalfMinM");
	_slopeFactorM[0] = this->template loadParameter<float>("slopeFactorM0");
	_slopeFactorM[1] = this->template loadParameter<float>("slopeFactorM1");
	_slopeFactorM[2] = this->template loadParameter<float>("slopeFactorM2");
	_tauScaleFactorM = this->template loadParameter<float>("tauScaleFactorM");

	_timestep = properties->timestep;

	return true;
}
