#include <CompartmentSimulator.h>
#include <slug/sim/CUDA.h>
#include <Compartment.cuh>

template<>
void CompartmentSimulator<slug::util::MemoryType::CUDA>::
update(UpdateParameters& parameters)
{
	auto channelCurrentBuffer = _channelSubscription->pull();
	auto oldCompartmentBuffer = _compartmentSubscription->pull();
	auto newCompartmentBuffer = _getBlank();
	if (this->numNeurons > channelCurrentBuffer->size)
	{
		std::cout << this->numNeurons << " " << channelCurrentBuffer->size << std::endl;
	}
#if 1
	compartment(_refractoryTime,
	            oldCompartmentBuffer->calcium,
				oldCompartmentBuffer->voltages,
				newCompartmentBuffer->calcium,
				newCompartmentBuffer->voltages,
				parameters.inputCurrent,
				channelCurrentBuffer->currentBuffer,
				_leakConductance,
				_leakReversal,
				parameters.synapticCurrentVector,
				parameters.voltageClamp,
				parameters.clampVoltage,
				_restVoltage,
				_persistence,
				_dtC,
				_threshold,
				_spikeShapeLength,
				_spikeShapes,
				_caSpikeIncrement,
				_caPersistence,
				parameters.neuronFireVector,
				_timestep,
				this->numNeurons);
#endif

#if 1
	_transfer<slug::util::MemoryType::CUDA, 
	          slug::util::MemoryType::CUDA>(parameters.neuronVoltage,
	                                        newCompartmentBuffer->voltages,
						                    this->numNeurons);
#endif
	slug::sim::CUDA::synchronize();
	
	this->publish(newCompartmentBuffer);
	oldCompartmentBuffer->release();
	channelCurrentBuffer->release();
	static int c = 0;
#if 0
	if (c > 10)
	exit(0);
	++c;
#endif
}

template<>
void CompartmentSimulator<slug::util::MemoryType::System>::
update(UpdateParameters& parameters)
{
	//TODO
}
