#include "ChannelCurrentBuffer.h"
#include "CompartmentSimulator.h"
#include "ChannelUpdater.h"
#include "KmChannel.h"
#include "KahpChannel.h"
#include "KaChannel.h"

using namespace slug;

extern "C"
{

void activate()
{
	{
		static const auto type = slug::util::MemoryType::CUDA;
		auto sim =
			new sim::SpecificFactory<sim::NeuronSimulator<type>,
			                         CompartmentSimulator<type>>("ncs5",
									                            "ncs5",
																0);
		sim::Manager<sim::Factory<sim::NeuronSimulator<type>>>::add(sim);
	}

	{
		static const auto type = slug::util::MemoryType::System;
		auto sim =
			new sim::SpecificFactory<sim::NeuronSimulator<type>,
			                         CompartmentSimulator<type>>("ncs5",
									                            "ncs5",
																0);
		sim::Manager<sim::Factory<sim::NeuronSimulator<type>>>::add(sim);
	}
}

}
