#include <slug/sim/SynapseSimulator.h>

using namespace slug;
using namespace slug::sim;

template<util::MemoryType MType>
class DummySimulator : public sim::SynapseSimulator<MType>
{
public:
	virtual bool init(const SimulationProperties* properties)
	{
		return true;
	}

	virtual void initWeights(float* weights,
	                         const SimulationProperties* properties)
	{
		this->template _zero<float>(weights, this->numSynapses);
	}

	typedef typename SynapseSimulator<MType>::UpdateParameters
	    UpdateParameters;

	virtual void update(UpdateParameters& parameters)
	{
	}
};

template<util::MemoryType MType>
void add()
{
	auto sim = 
		new sim::SpecificFactory<sim::SynapseSimulator<MType>,
		                         DummySimulator<MType>>
			("dummy", "dummy", 0);
	sim::Manager<sim::Factory<sim::SynapseSimulator<MType>>>::add(sim);
}

extern "C"
{

void activate()
{
	add<util::MemoryType::System>();
	add<util::MemoryType::CUDA>();
	add<util::MemoryType::OpenCL>();
}

}

