#pragma once

void receiveFirings(const unsigned char* RSEType,
				 	float* _USEBase,
					float* _USE,
					float* _RSE,
					const float* maxG,
					const float* tauDepression,
					const float* tauFacilitation,
					float* _lastFireTime,
					const float* lastPostFireTime,
					const bool* learningOn,
					const unsigned char* learningType,
					float* _positiveLearningModulator,
					const float* positivePeakTime,
					const float* positivePeakDeltaUSE,
					const float* negativeWindowWidth,
					const float* negativePeakTime,
					const float* negativePeakDeltaUSE,
					const float* negativeLearningModulator,
					const unsigned int* PSGLengths,
					float* firingValues,
					unsigned int* firingIndices,
					unsigned int* PSGCounts,
					unsigned int* totalFirings,
					const float elapsedTime,
					const unsigned int* synapseFireVector,
                    unsigned int numSynapses);

void computePostFirings(const unsigned int* neuronFireVector,
                        const unsigned int neuronFireVectorSize,
						const unsigned int* postNeuronID,
						float* _USEBase,
						const float* lastPreFireTime,
						float* lastPostFireTime,
						float* _negativeLearningModulator,
						const float* negativePeakTime,
						const float* negativePeakDeltaUSE,
						const float* positiveLearningModulator,
						const float* positiveWindowWidth,
						const float* positivePeakTime,
						const float* positivePeakDeltaUSE,
						const unsigned char* learningType,
						const bool* learningOn,
						const float elapsedTime,
						const unsigned int numSynapses);

void computeSynapticWeights(const float* firingValues,
                            const unsigned int* firingIndices,
							const unsigned int* PSGCounts,
							const float** PSGs,
							const float* synapticReversal,
							const unsigned int* postNeuronIDs,
							const float* voltages,
							float* synapticWeights,
							const unsigned int* _numIndices,
							unsigned int* newFiringIndices,
							unsigned int* newPSGCounts,
							float* newFiringValues,
							unsigned int* newNumIndices);
