#pragma once
#include <slug/sim/SpecificDevice.h>

namespace slug
{

namespace sim
{

/**
	A Device specialization for running simulation code on CUDA-capable
	devices.
*/
class CUDADevice : public SpecificDevice<util::MemoryType::CUDA>
{
public:
	virtual void threadInit();

	virtual void threadDestroy();

	virtual void readHeader(util::InputStream& bs);
private:
	///The CUDA device number to give to cudaSetDevice()
	int _cudaDeviceID;
};

} //namespace sim

} //namespace slug
