#pragma once
#include <slug/util/Unique.h>

namespace slug
{

namespace sim
{

struct SimulationProperties
{
	///Constructor
	SimulationProperties();

	///The timestep in seconds
	float timestep;

	///True if the simulation should run forever
	bool indefinite;

	///The number of timesteps to run the simulation for
	unsigned int numSteps;

	///The machine ID for this machine
	util::Unique myID;

	///The size of the global neuron fire vector
	unsigned int neuronFireVectorSize;
};

} //namespace sim

} //namespace slug
