template<typename T, typename F>
UniformExtractor<T,F>:: UniformExtractor(const std::string& n, const F& f)
	: _name(n),
	  _f(f)
{
}

template<typename T, typename F>
bool UniformExtractor<T,F>::serialize(ElementList& el, util::OutputStream& os)
{
	writeHeader(_name, el.size() * sizeof(T), os);
	for (auto e : el)
	{
		os << (T)(_f(e));
	}
}

template<typename T, typename F>
unsigned int UniformExtractor<T,F>::numParameters() const
{
	return 1;
}
