#pragma once
#include <slug/spec/Specification.h>
#include <slug/util/BinaryStream.h>
#include <slug/util/Unique.h>

namespace slug
{

namespace spec
{

/**
	Interface for objects that collect data on other objects.
*/
struct Report
{
	///Default constructor
	Report();

	///The type of this report plugin to use
	util::Unique type;

	///Global report specification
	Specification* specification;

	///A unique identifier for this report
	util::Unique id;

	///The master machine which collects the subreports
	util::Unique master;

	///The set of all machines involved including the master
	std::vector<util::Unique> machines;

	///Write out data specific to this classification of report
	virtual bool write(util::OutputStream& bs) = 0;

	///Determines the master and machine list
	virtual bool finalize() = 0;
};

///List of Report pointers
typedef std::vector<Report*> ReportList;

} //namespace spec

} //namespace slug

