#include <slug/sim/Reportable.h>

using namespace slug;
using namespace slug::sim;
using namespace slug::util;

Reportables* Reportables::_instance = nullptr;

Reportables* Reportables::instance()
{
	if (nullptr == _instance)
		_instance = new Reportables();
	return _instance;
}

bool Reportables::set(util::Unique reportableName,
                      const std::string& key,
					  Publisher* publisher)
{
	return instance()->_set(reportableName, key, publisher);
}

bool Reportables::_set(util::Unique reportableName,
                       const std::string& key,
					   Publisher* publisher)
{
	_reportables[reportableName][key] = publisher;
	return true;
}

Publisher* Reportables::get(util::Unique reportableName,
                            const std::string& key)
{
	return instance()->_get(reportableName, key);
}

Publisher* Reportables::_get(util::Unique reportableName,
                             const std::string& key)
{
	if (_reportables.count(reportableName) == 0)
	{
		std::cerr << "Reportable " << reportableName << " not found." <<
		    std::endl;
		return nullptr;
	}
	if (_reportables[reportableName].count(key) == 0)
	{
		std::cerr << "Key " << key << " not found." << std::endl;
		return nullptr;
	}
	return _reportables[reportableName][key];
}
