#include <slug/util/Strings.h>
#include <slug/util/Unique.h>
#include <stdexcept>
#include <iostream>

using namespace slug::util;

//Static variable allocations
std::map<std::string, Unique> StringID::_ids;
std::map<Unique, std::string> StringID::_strings;
std::mutex StringID::_lock;

Unique StringID::get(const std::string& s)
{
	_lock.lock();
	auto it = _ids.find(s);

	//If the string doesn't already have an ID
	if (it == _ids.end())
	{
		_ids[s] = Unique::generate();
		_strings[_ids[s]] = s;
	}
	Unique id = _ids[s];
	_lock.unlock();
	return id;
}

const std::string& StringID::get(Unique id)
{
	_lock.lock();
	auto it = _strings.find(id);
	if (it == _strings.end())
	{
		std::cout << "Could not find string for ID " << id << std::endl;
		throw(std::runtime_error(""));
	}
	const std::string& s = _strings[id];
	_lock.unlock();
	return s;
}
