#include <slug/sim/CUDADevice.h>
#include <cuda_runtime.h>
#include <slug/sim/CUDA.h>
#include <slug/util/Debug.h>

using namespace slug::sim;
using namespace slug;

void CUDADevice::threadInit()
{
	//Select the device
	cudaSafeCall(cudaSetDevice(_cudaDeviceID));

	//Create a stream for all code on this thread
	cudaSafeCall(cudaStreamCreate(&CUDA::stream));
}

void CUDADevice::threadDestroy()
{
	//Make sure all commands in the stream are done
	cudaSafeCall(cudaStreamSynchronize(CUDA::stream));

	//Destroy the stream object
	cudaSafeCall(cudaStreamDestroy(CUDA::stream));
}

void CUDADevice::readHeader(util::InputStream& bs)
{
	//The Device specification for CUDA devices have the device ID
	bs >> _cudaDeviceID;
}

