#include <slug/sim/Preference.h>

using namespace slug;
using namespace slug::sim;

bool PreferenceChain::operator()(const Plugin* lesser, const Plugin* greater)
{
	for (auto it : _preferences)
	{
		if (false == (*it)(lesser, greater))
			return false;
	}
	return true;
}

void PreferenceChain::push_back(Preference* preference)
{
	_preferences.push_back(preference);
}

bool RevisionPreference::operator()(const Plugin* lesser, const Plugin* greater)
{
	return lesser->revision() < greater->revision();
}

FeaturePreference::FeaturePreference(const std::string& key)
	: _key(key)
{
}

bool FeaturePreference::operator()(const Plugin* lesser, const Plugin* greater)
{
	return (greater->features().find(_key) != greater->features().end()) &&
	       (lesser->features().find(_key) == lesser->features().end());
}
