#include <slug/spec/Element.h>
#include <slug/spec/ElementPlugin.h>
#include <slug/spec/Machine.h>

using namespace slug::spec;
using namespace slug;

Element::Element(util::Unique _type)
	: type(_type)
{
}

bool Element::Location::operator<(const Location& rhs) const
{
	return plugin->id < rhs.plugin->id;
}

bool Element::Location::operator==(const Location& rhs) const
{
	return plugin->id == rhs.plugin->id;
}

util::Unique Element::Location::machine() const
{
	return plugin->location.machine->id;
}

util::Unique Element::Location::device() const
{
	return plugin->location.device->id;
}

unsigned int Element::deviceID() const
{
	return pluginID + location.plugin->offset.device;
}

unsigned int Element::machineID() const
{
	return pluginID + location.plugin->offset.machine;
}

unsigned int Element::globalID() const
{
	return pluginID + location.plugin->offset.global;
}
