#include <slug/spec/InputPlugin.h>

using namespace slug::spec;
using namespace slug;

InputPlugin::InputPlugin(util::Unique _type)
	: ElementPlugin(_type)
{
}

auto inputUnique = util::StringID::get("input");

util::Unique InputPlugin::genre() const
{
	return inputUnique;
}

bool InputPlugin::addInput(Input* i)
{
	inputs.push_back(i);
	i->location.plugin = this;
	return true;
}

bool InputPlugin::write(util::OutputStream& bs)
{
	//Inputs need to know the device-level neuron ID in order to affect them
	for (auto input : inputs)
		bs << input->neuron->deviceID();
	return true;
}

unsigned int InputPlugin::count() const
{
	return inputs.size();
}

Element* InputPlugin::element(unsigned int index)
{
	return inputs[index];
}
