#include <slug/spec/Synapse.h>
#include <slug/spec/Neuron.h>

using namespace slug::spec;
using namespace slug;

Synapse::Synapse(util::Unique _type,
                 unsigned int _delay,
				 Neuron* a,
				 Neuron* b)
	: Element(_type),
	  delay(_delay),
	  presynapticNeuron(a),
	  postsynapticNeuron(b)
{
	type = _type;
	if (nullptr != a && nullptr != b)
	{
		connect(a, b);
	}
	else
		presynapticNeuron = postsynapticNeuron = nullptr;
}

bool Synapse::connect(Neuron* a, Neuron* b)
{
	b->incomingSynapses.push_back(this);
	presynapticNeuron = a;
	postsynapticNeuron = b;
	return true;
}
