#include <slug/spec/SynapsePlugin.h>

using namespace slug::spec;
using namespace slug;

SynapsePlugin::SynapsePlugin(util::Unique _type)
	: ElementPlugin(_type)
{
}

auto synapseUnique = util::StringID::get("synapse");

util::Unique SynapsePlugin::genre() const
{
	return synapseUnique;
}

bool SynapsePlugin::addSynapse(Synapse* s)
{
	synapses.push_back(s);
	s->location.plugin = this;
	return true;
}

unsigned int SynapsePlugin::count() const
{
	return synapses.size();
}

Element* SynapsePlugin::element(unsigned int index)
{
	return synapses[index];
}

bool SynapsePlugin::write(util::OutputStream& bs)
{
	for (auto synapse : synapses)
		bs << synapse->postsynapticNeuron->deviceID();
	return true;
}

