#include <slug/util/Barrier.h>

using namespace slug;
using namespace slug::util;

Barrier::Barrier(unsigned int numParticipants)
	: _numParticipants(numParticipants),
	  _present(0)
{
}

void Barrier::join()
{
	//Only one thread can modify the tally at a time
	_lock.lock();

	//Tally ourself
	++_present;

	//If we're the last, release everybody
	if (_present == _numParticipants)
	{
		_allPresent.notify_all();
		_present = 0;
	}
	else //Otherwise, unlock and wait for the last one to join
		_allPresent.wait(_lock);

	//Release the lock after it gets reacquired from waking
	_lock.unlock();
}
