#include <slug/util/IO.h>
#include <sys/stat.h>
#include <string.h>
#include <dirent.h>
#include <iostream>

namespace slug
{

namespace util
{

namespace io
{

bool rmdir(const std::string& path)
{
	DIR* directory = opendir(path.c_str());
	if (nullptr == directory)
	{
		std::cerr << "Failed to open directory " << path << std::endl;
		return false;
	}

	for (struct dirent* entry = readdir(directory); 
	     entry != nullptr; entry = readdir(directory))
	{
		if (0 == strcmp(entry->d_name, ".") || 
		    0 == strcmp(entry->d_name, ".."))
			continue;
		std::string filePath = path + "/" + std::string(entry->d_name);
		struct stat fileStat;
		if (0 == stat(filePath.c_str(), &fileStat))
		{
			if (S_ISDIR(fileStat.st_mode))
			{
				if (!rmdir(filePath))
				{
					std::cerr << "Failed to remove directory " << filePath <<
						std::endl;
					return false;
				}
			}
			else if (0 != remove(filePath.c_str()))
			{
				std::cerr << "Failed to remove file " << filePath << std::endl;
				return false;
			}
		}
	}
	closedir(directory);
	return 0 == remove(path.c_str());
}

} //namespace io

} //namespace util

} //namespace slug
